% This file is used to generate data from the policy functions generated in
% bullionistsim3.mod, conducts Granger causality tests for each of the
% 100,000 simulations, and prints the average p-value from these tests.


% Generate four shocks . . . 100000 times

clear all;
clc;

em = normrnd(0,0.055,[200 100000]);
eg = normrnd(0,0.029,[200 100000]);
emstar = normrnd(0,0.255,[200 100000]);
egstar = normrnd(0,0.01,[200 100000]);

for n=1:100000;
    p(1,n) = 0;
    m(1,n) = 0;
    g(1,n) = 0;
    emm(1,n) = 0;
    egg(1,n) = 0;
    mstar(1,n) = 0;
    gstar(1,n) = 0;
    e(1,n) = 0;
end;

i = 2;
j = 1;

while j<=100000;
    for i=2:200;
        p(i,j) = 0.30 + 0.06*m(i-1,j) + 0.10*g(i-1,j) + 0.12*emm(i-1,j) + 1.65*egg(i-1,j) + 0.19*em(i,j) + 1.73*eg(i,j);
        m(i,j) = 1 + 0.95*m(i-1,j) + 0.09*g(i-1,j) + 0.67*emm(i-1,j) + 0.09*egg(i-1,j) + em(i,j) + 0.10*eg(i,j);
        g(i,j) = 1 + 0.952*g(i-1,j) + 0.952*egg(i-1,j) + eg(i,j);
        mstar(i,j) = 1 + 0.99*mstar(i-1,j) + emstar(i,j);
        e(i,j) = 1 -0.19*m(i-1,j) - 0.33*g(i-1,j) + 0.56*mstar(i-1,j) - 0.41*emm(i-1,j) - 5.50*egg(i-1,j) - 0.62*em(i,j) - 5.77*eg(i,j) + 0.57*emstar(i,j);
        emm(i,j) = 0.67*emm(i-1,j) + em(i,j);
        egg(i,j) = 0.952*egg(i-1,j) + eg(i,j);
    end;
    j=j+1;
end;

j = 1;
while j<=100000;
    y = [p(101:200,j) m(101:200,j) g(101:200,j)];
    results = vare(y,1);
    pvalue(j,1) = results(1).fprob(2,1);
    j = j+1;
end;

averagepvalue = mean(pvalue(:,1));
    







